const server = 'http://192.168.4.22'

async function login(username, password) {
    let formData = new FormData();
    formData.append('username', username)
    formData.append('password', password);
    formData.append('action', 'login');
    const resp = fetch(`${server}/api/auth`, { method: 'POST', mode: 'cors', body: formData }).then(resp => resp.text());
    return resp;
}
async function logout(token) {
    let formData = new FormData()
    formData.append('token', token);
    formData.append('action', 'logout');
    const resp = fetch(`${server}/api/auth`, { method: 'POST', mode: 'cors', body: formData }).then(resp => resp.text());
    return resp;
}
function checkAuth(token) {
    return token === 'DUMMYTOKEN';
}
async function fetchdb(token = 'azif7eqCl5') {
    //fetch(`${server}/api/userdb`).then()
    //let xmlHttp = new XMLHttpRequest();
    //xmlHttp.open( "GET", `${server}/api/userdb`, false ); // false for synchronous request
    //xmlHttp.send( null );
    const resp = await fetch(`${server}/api/userdb`, { method: 'GET', mode: 'cors', headers: { Authentification: token } })
        .then(resp => resp.text()).then(text => parsedb(text))
    return resp;

}
function createCsvTable(userdb) {
    let res = '';
    let first = true;
    for (let u of userdb) {
        if (first)
            first = false;

        res += `${!first && '\n'}${u.uid},${u.first_name},${u.last_name},${u.rfid_uid},${u.user_pin},${u.enabled ? '1' : '0'}`;
    }
    return res;
}
async function updateUser(token, user) {
    const resp = await fetch(`${server}/api/user/`, { method: 'POST', body: JSON.stringify(user), mode: 'cors', headers: { Authentification: token } })
        .then(resp => resp.json());
    return resp;
}
async function deleteUser(token, user) {
    const resp = await fetch(`${server}/api/user/${user.uid}`, { method: 'DELETE', body: JSON.stringify(user), mode: 'cors', headers: { Authentification: token } })
        .then(resp => resp.json());
    return resp;
}
async function createUser(token, user) {
    const resp = await fetch(`${server}/api/user/`, { method: 'PUT', body: JSON.stringify(user), mode: 'cors', headers: { Authentification: token } })
        .then(resp => resp.json());
    return resp;
}
function parsedb(raw) {

    let lines = raw.split('\n');
    let users = [];
    lines.map((l, line) => {
        let [uid, first_name, last_name, rfid_uid, user_pin, enabled] = l.split([';']);
        users.push({ line, uid, first_name, last_name, rfid_uid, user_pin, enabled: enabled[0] === '1' });
    });
    return users;

}
const publicfunctions = {  login, logout, checkAuth, parsedb,fetchdb, createCsvTable, updateUser, deleteUser, createUser  };
export default { ...publicfunctions }
export { login, logout, checkAuth, parsedb,fetchdb, createCsvTable, updateUser, deleteUser, createUser }