import { h } from 'preact';
import { useContext, useEffect, useState } from 'preact/hooks';
import { route } from 'preact-router';
import AppState, { UserTable } from "../../store";
import api from '../../api'
function EditUser({ userid }) {
    let [sessiondata,] = useContext(AppState).session;
    const { usertable, userreducer } = useContext(UserTable);
    
    const [formdata, formchange] = useState({});
    const onChange = (e) => {
        console.log(e);
        if (e.target.type === 'checkbox')
            formchange({ ...formdata, [e.target.id]: e.target.checked })
        else
            formchange({ ...formdata, [e.target.id]: e.target.value })
    }
    useEffect(()=>{
        let user = userid !== undefined?usertable.find(u => u.uid === userid):undefined;
        if(user!==undefined){
            formchange(user);
        }
    },[userid]);
    const onSubmit = (e) => {
        e.preventDefault();
        console.log(api);
        if(formdata.line!==undefined){
            api.updateUser(sessiondata.token, formdata).then(r => {
                userreducer({ type: 'update', user: r })
            });
        }else{
            api.createUser(sessiondata.token, formdata).then(r => {
                userreducer({ type: 'create', user: r })
            });
        }

        route('/users');
    }
    const Input = ({ id, type = 'text', label, disabled }) => (<div className={'textbox'} ><input placeholder=" " disabled={disabled} type={type} checked={type == 'checkbox' && formdata[id] ? 'on' : ''} value={formdata[id]} id={id} onChange={onChange} name={`edit-${id}`} /><label for={id}>{label}</label></div>)
    return (
        <div className='container'>
            <h1>{formdata.line != undefined ? "Benutzer Bearbeiten" : "Neuer Benutzer"}</h1>
            <form onSubmit={onSubmit}>
                <Input id="uid" label="UserID" />
                <Input id="first_name" label="Vorname" />
                <Input id="last_name" label="NachName" />
                <Input id="rfid_uid" label="RFID" />
                <Input id="user_pin" label="Pin" />
                <Input id="enabled" type={'checkbox'} label="" />
                <div className={'button'} ><input type={'submit'}>Speichern</input> </div>

            </form>
        </div>
    )
}
export default EditUser;