import { h } from 'preact';
import { route } from 'preact-router';
import { useContext, useState } from 'preact/hooks';
import AppState from '../../store/AppState';
import Breadcrumbs from '../../components/breadcrumbs';
import api from '../../api'
function Login() {
    let [sessiondata, setsession] = useContext(AppState).session;
    const [val, set] = useState({ username: '', password: '', error: null });
    const navigation = ["Login"];
    if (sessiondata.active)
        route('/', true);
    function onSubmit(e) {
        e.preventDefault();
        api.login(val.username, val.password).then(token => {
            if (token != 'failed!') {
                let newsession = {
                    type: 'start',
                    username: val.username,
                    token
                }
                setsession(newsession);
            }
            else {
                set({ ...val, error: "user" });
            }
            set({ username: '', password: '' });
        })

    }
    return (
        <div class="container">
            <Breadcrumbs items={navigation} />
            <div className={'contentbox'} >
            <h2>Anmeldung</h2>
            <p >Bitte melden Sie sich mit ihren Nutzerdaten an.</p>
            {val.error !== null && <span style={'color: red'}>Fehler: Ungültige Anmeldedaten.</span>}
                <form id="login_form" onSubmit={onSubmit} >

                    
                    <div class="input-box">
                        <input id="name" type="text" placeholder="Username" onInput={e => set({ ...val, username: e.target.value })} value={val.username} />
                        <label for="name">Benutzername</label>
                    </div>
                    <div class="input-box">
                        <input id="pass" type="password" placeholder="Passwort" onInput={e => set({ ...val, password: e.target.value })} value={val.password} />
                        <label for="pass">Password</label>
                    </div>
                    <div class={'button'} onClick={onSubmit} ><input type="submit" value="Anmelden" /></div>

                </form>
            </div>
        </div>
    );

}

export default Login;